/*
+-------------------------------- DISCLAIMER ---------------------------------+
|                                                                             |
| This application program is provided to you free of charge as an example.   |
| Despite the considerable efforts of Euresys personnel to create a usable    |
| example, you should not assume that this program is error-free or suitable  |
| for any purpose whatsoever.                                                 |
|                                                                             |
| EURESYS does not give any representation, warranty or undertaking that this |
| program is free of any defect or error or suitable for any purpose. EURESYS |
| shall not be liable, in contract, in torts or otherwise, for any damages,   |
| loss, costs, expenses or other claims for compensation, including those     |
| asserted by third parties, arising out of or in connection with the use of  |
| this program.                                                               |
|                                                                             |
+-----------------------------------------------------------------------------+
*/

//
//  FirstExpert Project
//
//  FirstExpertApp class definition
//  File: FirstExpertApp.cpp
//////////////////////////////////////////////////////////////////////////////////

// Application Header
//////////////////////////////////////////////////////////////////////////////////
#include "FirstExpert.h"

// Macros
//////////////////////////////////////////////////////////////////////////////////
IMPLEMENT_APP(FirstExpertApp)

// Event Table
//////////////////////////////////////////////////////////////////////////////////
BEGIN_EVENT_TABLE(FirstExpertApp, wxApp)

END_EVENT_TABLE()

// Constructors 
//////////////////////////////////////////////////////////////////////////////////
FirstExpertApp::FirstExpertApp()
{
    m_pDocManager=(wxDocManager*)NULL;
    m_pMainFrame=(MainFrame*)NULL;
    m_bInitialized=false;
}


// Accessors 
//////////////////////////////////////////////////////////////////////////////////
MainFrame* FirstExpertApp::GetMainFrame()
{
    return m_pMainFrame;
}


// Event Handlers 
//////////////////////////////////////////////////////////////////////////////////
bool FirstExpertApp::OnInit()
{
    // Create the document manager
    m_pDocManager=new wxDocManager();

    // Create a document template
    wxDocTemplate *pDocTemplateBmp=new wxDocTemplate(m_pDocManager,wxT("BMP files"), wxT("*.bmp"), wxT(""), wxT("bmp"),
        wxT("Image"), wxT("View"),
        CLASSINFO(FirstExpertDoc),
        CLASSINFO(FirstExpertView));

    // Only one document at a time
    m_pDocManager->SetMaxDocsOpen(1);

    // + MultiCam FirstExpert sample program
    // Initializing GDK_RGB
    gdk_rgb_init();

    gtk_widget_set_default_colormap(gdk_rgb_get_cmap());
    gtk_widget_set_default_visual(gdk_rgb_get_visual());
    // - MultiCam FirstExpert sample program

    // create the main application window
    m_pMainFrame = new MainFrame(m_pDocManager,(wxFrame*)NULL,
        wxT(APPLICATION_TITLE),wxPoint(0,0),wxSize(1000,800),wxDEFAULT_FRAME_STYLE|wxFRAME_NO_WINDOW_MENU);

    // Create the document
    m_pDocManager->CreateDocument(wxT(""),wxDOC_NEW);

    if (!m_bInitialized)
        return false;

    // and show it (the frames, unlike simple controls, are not shown when
    // created initially)
    m_pMainFrame->Centre(wxBOTH);
    m_pMainFrame->Show(TRUE);

    // success: wxApp::OnRun() will be called which will enter the main message
    // loop and the application will run. If we returned FALSE here, the
    // application would exit immediately.

    return true;
}

int FirstExpertApp::OnExit()
{
    // Delete the document manager
    if(m_pDocManager!=NULL)
        delete m_pDocManager;

    return 0;
}
