/*
+-------------------------------- DISCLAIMER ---------------------------------+
|                                                                             |
| This application program is provided to you free of charge as an example.   |
| Despite the considerable efforts of Euresys personnel to create a usable    |
| example, you should not assume that this program is error-free or suitable  |
| for any purpose whatsoever.                                                 |
|                                                                             |
| EURESYS does not give any representation, warranty or undertaking that this |
| program is free of any defect or error or suitable for any purpose. EURESYS |
| shall not be liable, in contract, in torts or otherwise, for any damages,   |
| loss, costs, expenses or other claims for compensation, including those     |
| asserted by third parties, arising out of or in connection with the use of  |
| this program.                                                               |
|                                                                             |
+-----------------------------------------------------------------------------+
*/

//
//	FirstExpert Project	
//
//	FirstExpertApp class declaration
//	File: FirstExpertApp.h
//////////////////////////////////////////////////////////////////////////////////

// Header macro definition
//////////////////////////////////////////////////////////////////////////////////
#ifndef FirstExpertApp_h
#define FirstExpertApp_h

// Class definition
//////////////////////////////////////////////////////////////////////////////////
class FirstExpertApp : public wxApp
{
// Constructors
public:
    FirstExpertApp();

// Variables
private:
    wxDocManager* m_pDocManager;
    MainFrame* m_pMainFrame;
    bool m_bInitialized;

// Accessors
public:
    MainFrame* GetMainFrame();
    void SetInitialized() {m_bInitialized=true;};

// Event Handlers
public:
    virtual bool OnInit();
    int OnExit();

private:
    DECLARE_EVENT_TABLE()
};

// Macros
//////////////////////////////////////////////////////////////////////////////////

// + MultiCam FirstExpert sample program
#define APPLICATION_TITLE "FirstExpert"
#define APPLICATION_COPYRIGHT "FirstExpert 2.0\n\n(c) 2007"
#define APPLICATION_ABOUT "About FirstExpert"
#define DOCUMENT_TITLE "FirstExpert"

#define EURESYS_SAMPLE_PROGRAM_CAM_FILENAME "P2-4x-06k40_L6144RG"
#define EURESYS_SAMPLE_CAMERA_MODEL "DALSA-P2-4x-06k40"
// - MultiCam FirstExpert sample program

DECLARE_APP(FirstExpertApp)

// Application icon
//////////////////////////////////////////////////////////////////////////////////
#include "res/FirstExpert.xpm"
#include "res/grab.xpm"
#include "res/help.xpm"

#endif
