/*
+-------------------------------- DISCLAIMER ---------------------------------+
|                                                                             |
| This application program is provided to you free of charge as an example.   |
| Despite the considerable efforts of Euresys personnel to create a usable    |
| example, you should not assume that this program is error-free or suitable  |
| for any purpose whatsoever.                                                 |
|                                                                             |
| EURESYS does not give any representation, warranty or undertaking that this |
| program is free of any defect or error or suitable for any purpose. EURESYS |
| shall not be liable, in contract, in torts or otherwise, for any damages,   |
| loss, costs, expenses or other claims for compensation, including those     |
| asserted by third parties, arising out of or in connection with the use of  |
| this program.                                                               |
|                                                                             |
+-----------------------------------------------------------------------------+
*/

//
//  FirstExpert Project
//
//  FirstExpertDoc class declaration
//  File: FirstExpertDoc.h
//////////////////////////////////////////////////////////////////////////////////

// Header macro definition
//////////////////////////////////////////////////////////////////////////////////
#ifndef FirstExpertDoc_h
#define FirstExpertDoc_h

// + MultiCam FirstExpert sample program
#include "multicam.h"

#ifndef BYTE
    #define BYTE unsigned char
#endif

// - MultiCam FirstExpert sample program

// Class definition
//////////////////////////////////////////////////////////////////////////////////
class FirstExpertDoc : public wxDocument
{
// Constructors
public:
    FirstExpertDoc();
    ~FirstExpertDoc();

// Variables
private:

    // + MultiCam FirstExpert sample program
    MCHANDLE m_hChannel;
    MCHANDLE m_hSurface;
    PVOID m_pAllocatedBuffer;
    PUINT8 m_pImageBuffer;

    INT32 m_n32ImageWidth, m_n32ImageHeight;

// Event Handlers
public:
    void OnGrab(wxCommandEvent& event);

    virtual bool OnNewDocument();

// Methods
public:

    bool MultiCam_Init();
    void MultiCam_Exit();
    void MultiCam_CallBackFunction(PMCCALLBACKINFO CInfo);
    PUINT8 GetBuffer() {return m_pImageBuffer;};
    INT32 GetWidth() {return m_n32ImageWidth;};
    INT32 GetHeight() {return m_n32ImageHeight;};
    // - MultiCam FirstExpert sample program

private:
    DECLARE_DYNAMIC_CLASS(FirstExpertDoc);
    DECLARE_EVENT_TABLE()
};

#endif // END of header macro definition
